//
//  GSAPI.m
//  GigyaGSAPITester
//
//  Created by Moshe Shitrit on 7/16/10.
//  Copyright 2010 Mitug Distributed Systems Ltd. All rights reserved.
//

#import "GSAPI_Internal.h"
#import	"GSWebViewController.h"
#import	"GSResponse.h"
#import	"GSRequest.h"




@implementation GSAPI_Internal

@synthesize	m_pAPIKey;
@synthesize	m_pMainViewController;
@synthesize	m_pSettings;
@synthesize	m_pSession;
@synthesize	m_pNotificationMessage;
@synthesize	m_bNoReEntrantCallPending;
@synthesize	delegate;
@synthesize	m_pSavedRequestParams;



- (id)initWithAPIKey:(NSString *)APIKey ViewController:(UIViewController *)MainViewController delegate:(id)pDelegate {
	if ((self = [super init])) {
		self.m_pAPIKey = APIKey;
		self.delegate	=	pDelegate;
		self.m_pMainViewController = MainViewController;
		[self LoadSettings];
		[self LoadSession];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:GetUserInfoCompletedAfterLogin_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:GetUserInfoCompletedAfterConnect_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:LoginCompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:LogoutCompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:AddConnectionCompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:RemoveConnectionCompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowLoginUICompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:SendRequestCompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowAddConnectionsUICompleted_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowAddConnectionsUILoaded_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowLoginUILoaded_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowAddConnectionsUIFailed_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowLoginUIFailed_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowAddConnectionsUIClosed_Notification object: nil ];
		[[ NSNotificationCenter defaultCenter] addObserver:self selector: @selector(OnNotification:) name:ShowLoginUIClosed_Notification object: nil ];
		
		
		
	}
	return self;
}


- (void) OnNotification:(NSNotification *)pNotification
{
	self.m_bNoReEntrantCallPending	=	NO;
	self.m_pNotificationMessage	=	nil;
	
	GSDictionary *pRequest = [pNotification.userInfo objectForKey:GSAPI_PARAM_NAME_REQUEST_PARAMS_DICTIONARY];
	GSResponse *pResponse = [pNotification.userInfo objectForKey:GSAPI_PARAM_NAME_GSRESPONSE];
	NSString	*pMethod = [pNotification.userInfo objectForKey:GSAPI_PARAM_NAME_SEND_REQUEST_METHOD];
	id	pContext = [pNotification.userInfo objectForKey:GSAPI_PARAM_NAME_CONEXT];
	
	if(pResponse.errorCode == GSErrorCode_CancelledByUser)
		return;
	
	if([pNotification.name compare:LoginCompleted_Notification] == NSOrderedSame)
	{
		if(pResponse.errorCode != 0)
			[self.delegate onLoginCompleted:pRequest  response:pResponse context:pContext];
		else
			[self GetUserInfo:GetUserInfoCompletedAfterLogin_Notification context:pContext originalRequest:pRequest];
	}
	else		if([pNotification.name compare:ShowLoginUICompleted_Notification] == NSOrderedSame)
	{
		if(pResponse.errorCode != 0)
			[self.delegate onShowLoginUICompleted:pRequest  response:pResponse context:pContext];
		else
			[self GetUserInfo:GetUserInfoCompletedAfterLogin_Notification context:pContext originalRequest:pRequest];
	}
	
	else	if([pNotification.name compare: GetUserInfoCompletedAfterLogin_Notification] == NSOrderedSame)
		[self.delegate onLoginCompleted:self.m_pSavedRequestParams  response:pResponse context:pContext];
	else	if([pNotification.name compare: GetUserInfoCompletedAfterConnect_Notification] == NSOrderedSame)
		[self.delegate onAddConnectionCompleted:self.m_pSavedRequestParams  response:pResponse context:pContext];
	else	if([pNotification.name compare:LogoutCompleted_Notification] == NSOrderedSame)
	{
		self.m_pSession	=	nil;
		[self SaveSession];
		[self.delegate onLogoutCompleted:pResponse];
	}
	else		if([pNotification.name compare:AddConnectionCompleted_Notification] == NSOrderedSame)
	{
		if(pResponse.errorCode != 0)
			[self.delegate onAddConnectionCompleted:pRequest  response:pResponse  context:pContext];
		else
			[self GetUserInfo:GetUserInfoCompletedAfterConnect_Notification  context:pContext originalRequest:pRequest];
		
	}
	else		if([pNotification.name compare:RemoveConnectionCompleted_Notification] == NSOrderedSame)
		[self.delegate onRemoveConnectionCompleted:pRequest  response:pResponse context:pContext];
	else		if([pNotification.name compare:SendRequestCompleted_Notification] == NSOrderedSame)
		[self.delegate onSendRequestCompleted:pMethod Params:pRequest  response:pResponse context:pContext];
	else		if([pNotification.name compare:ShowAddConnectionsUICompleted_Notification] == NSOrderedSame)
	{
		if(pResponse.errorCode != 0)
			[self.delegate onShowAddConnectionsUICompleted:pRequest  response:pResponse context:pContext];
		else
			[self GetUserInfo:GetUserInfoCompletedAfterConnect_Notification  context:pContext originalRequest:pRequest];
		
	}	else	if([pNotification.name compare:ShowAddConnectionsUILoaded_Notification] == NSOrderedSame)
		[self.delegate onShowAddConnectionsUILoaded:pRequest  response:pResponse context:pContext];
	else	if([pNotification.name compare:ShowAddConnectionsUIFailed_Notification] == NSOrderedSame)
		[self.delegate onShowAddConnectionsUIFailed:pRequest  response:pResponse context:pContext];
	else	if([pNotification.name compare:ShowAddConnectionsUIClosed_Notification] == NSOrderedSame)
		[self.delegate onShowAddConnectionsUIClosed:pRequest  response:pResponse context:pContext];
	else	if([pNotification.name compare:ShowLoginUILoaded_Notification] == NSOrderedSame)
		[self.delegate onShowLoginUILoaded:pRequest  response:pResponse context:pContext];
	
	else	if([pNotification.name compare:ShowLoginUIFailed_Notification] == NSOrderedSame)
		[self.delegate onShowLoginUIFailed:pRequest  response:pResponse context:pContext];
	else	if([pNotification.name compare:ShowLoginUIClosed_Notification] == NSOrderedSame)
		[self.delegate onShowLoginUIClosed:pRequest  response:pResponse context:pContext];
	
}

-	(void) GetUserInfo:(NSString *)pNotificationName  context:(id)pContext originalRequest:(GSDictionary *)pRequestParams
{
	if(pRequestParams	!=	nil)
		self.m_pSavedRequestParams	=	pRequestParams;
	self.m_pNotificationMessage	=	pNotificationName;
	[self SendRequest:@"socialize.getUserInfo" Params:nil UseHTTPS:NO context:pContext];
}


-(void) LoadSettings
{
	NSString	*pSettingsFile = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"GSAPI_Settings"];
	self.m_pSettings	= [NSMutableDictionary	dictionaryWithContentsOfFile:pSettingsFile];
	if(self.m_pSettings	==	nil)
	{
		self.m_pSettings	=	[[NSMutableDictionary	alloc]init];
		[self.m_pSettings	setObject:@"Initialized" forKey:@"SettingsStatus"];
		[self SaveSettings];
	}
}
-(void) SaveSettings
{
	NSString	*pSettingsFile = [[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"GSAPI_Settings"];
	[self.m_pSettings writeToFile:pSettingsFile atomically:YES];
	
}
-(NSString	*) GetLastLoginProvider
{
	return [self.m_pSettings	objectForKey:@"LastLoginProvider"];
}
-(void) SetLastLoginProvider:(NSString	*)pProvider
{
	[self.m_pSettings	setObject:pProvider forKey:@"LastLoginProvider"];
	[self SaveSettings];
}

-(void) LoadSession
{
	self.m_pSession	=	[[GSSession	alloc]	init];
	
	self.m_pSession.secret	=	[self.m_pSettings	objectForKey:@"session.Secret"];
	self.m_pSession.accessToken	=	[self.m_pSettings	objectForKey:@"session.Token"];
	self.m_pSession.expirationTime	=	[self.m_pSettings	objectForKey:@"session.ExpirationTime"];
}
-(void) SetSession:(GSSession *)pSession
{
	self.m_pSession	=	pSession;
	[self SaveSession];
}

-(void) SaveSession
{
	if(self.m_pSession	!=	nil)
	{
		[self.m_pSettings	setObject:self.m_pSession.secret forKey:@"session.Secret"];
		[self.m_pSettings	setObject:self.m_pSession.accessToken forKey:@"session.Token"];
		[self.m_pSettings	setObject:self.m_pSession.expirationTime forKey:@"session.ExpirationTime"];
	}	else {
		[self.m_pSettings	removeObjectForKey:@"session.Secret"];
		[self.m_pSettings	removeObjectForKey:@"session.Token"];
		[self.m_pSettings	removeObjectForKey:@"session.ExpirationTime"];
	}
	[self SaveSettings];
	
}

-	(NSString	*) GetAccessToken
{
	if(self.m_pSession	==	nil)
		return nil;
	if([self.m_pSession IsValid]	==	YES)
		return self.m_pSession.accessToken;
	return nil;
}

-	(NSString	*) GetSecretKey
{
	if(self.m_pSession	==	nil)
		return nil;
	if([self.m_pSession IsValid]	==	YES)
		return self.m_pSession.secret;
	return nil;
}




- (void)dealloc {
	self.m_pAPIKey	=	nil;
	self.m_pMainViewController	=	nil;
	self.m_pSettings	=	nil;
	self.m_pSession	=	nil;
	self.m_pNotificationMessage	=	nil;
	self.m_pSavedRequestParams=nil;
	self.delegate	=	nil;
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[super dealloc];
}

- (void)GSWebViewControllerDidFinish:(UIViewController *)controller {
	GSWebViewController *pWebViewController = (GSWebViewController *)controller;
	[self.m_pMainViewController dismissModalViewControllerAnimated:YES];
	if(pWebViewController.m_pResponse == nil)
		return;
	
	if(pWebViewController.m_pResponse.errorCode	==	0)
	{
		if(pWebViewController.m_EventType == GSEventType_LOGIN)
		{
			self.m_pSession = [[GSSession alloc] initWithLoginResponse:pWebViewController.m_pResponse.data];
			[self SaveSession];
			[self SetLastLoginProvider:[pWebViewController GetProvider]];
		}
	}
	[self SendNotification:pWebViewController.m_pNotificationMessage	APIMethod:nil request:pWebViewController.m_pRequestParams response:pWebViewController.m_pResponse context:pWebViewController.m_pSavedContext];
}

- (void) Login:(GSDictionary *)pParams	context:(id)pContext
{
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:LoginCompleted_Notification	APIMethod:@"login" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:pContext];
		return;
	}
	self.m_pNotificationMessage	=	LoginCompleted_Notification;
	
	if([pParams getString:GSAPI_PARAM_NAME_PROVIDER]	==	nil	|| [[[pParams getString:GSAPI_PARAM_NAME_PROVIDER] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] length] == 0)
	{
		[self SendNotification:@"login" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_MissingArgument] autorelease] context:pContext];
		return;
	}
	
	if(self.m_pAPIKey	==	nil)
	{
		[self SendNotification:@"login" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_MissingAPIKey] autorelease] context:pContext];
		return;
	}
	
	
	
	
	self.m_bNoReEntrantCallPending	=	YES;
	GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
	pController.delegate = self;
	pController.m_pRequestParams	=	pParams;
	pController.m_EventType	=	GSEventType_LOGIN;
	pController.m_ActionType	=	GSWebAction_NavigateToLogin;
	pController.m_pGSAPI	=	self;
	pController.m_pSavedContext	=	pContext;
	pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
	UINavigationController *navigationController = [[UINavigationController alloc]
													initWithRootViewController:pController];
	navigationController.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
	[self.m_pMainViewController presentModalViewController:navigationController animated:YES];
	
	[pController release];	
	[navigationController release];
}

-(void) Logout
{
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:LogoutCompleted_Notification APIMethod:@"socialize.logout" request:nil response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:nil];
		return;
	}
	NSHTTPCookieStorage *pStorage = [NSHTTPCookieStorage sharedHTTPCookieStorage];
	for(NSHTTPCookie *pCookie in [pStorage cookies])
	{
		[pStorage deleteCookie:pCookie];
	}
	
	
	if([self GetAccessToken]	==	nil)
	{
		[self SendNotification:LogoutCompleted_Notification APIMethod:@"socialize.logout" request:nil response:[[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession] autorelease] context:nil];
		return;
	}
	self.m_pNotificationMessage	=	LogoutCompleted_Notification;
	
	[self SendRequest:@"socialize.logout" Params:nil UseHTTPS:NO context:nil];
}



- (void) AddConnection:(GSDictionary *)pParams	context:(id)pContext
{
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:AddConnectionCompleted_Notification APIMethod:@"connect" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:pContext];
		return;
	}
	
	
	
	if([pParams getString:GSAPI_PARAM_NAME_PROVIDER]	==	nil	|| [[[pParams getString:GSAPI_PARAM_NAME_PROVIDER] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] length] == 0)
	{
		[self SendNotification:AddConnectionCompleted_Notification APIMethod:@"connect" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_MissingArgument] autorelease] context:pContext];
		return;
	}
	
	if([self GetAccessToken]	==	nil)
	{
		[self SendNotification:AddConnectionCompleted_Notification APIMethod:@"connect" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession] autorelease] context:pContext];
		return;
	}
	self.m_pNotificationMessage	=	AddConnectionCompleted_Notification;
	
	self.m_bNoReEntrantCallPending	=	YES;
	GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
	pController.delegate = self;
	pController.m_pRequestParams	=	pParams;
	pController.m_EventType	=	GSEventType_CONNECT;
	pController.m_ActionType	=	GSWebAction_NavigateToConnect;
	pController.m_pGSAPI	=	self;
	pController.m_pSavedContext	=	pContext;
	pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
	UINavigationController *navigationController = [[UINavigationController alloc]
													initWithRootViewController:pController];
	navigationController.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
	[self.m_pMainViewController presentModalViewController:navigationController animated:YES];
	
	[pController release];	
	[navigationController release];
}



-(void) ShowLoginUI:(GSDictionary *)pParams	context:(id)pContext
{
	
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:ShowLoginUICompleted_Notification APIMethod:@"login" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:pContext];
		return;
	}
	self.m_bNoReEntrantCallPending	=	YES;
	self.m_pNotificationMessage	=	ShowLoginUICompleted_Notification;
	
	GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
	pController.delegate = self;
	pController.m_pRequestParams	=	pParams;
	pController.m_EventType	=	GSEventType_LOGIN;
	pController.m_ActionType	=	GSWebAction_NavigateToProviderSelector;
	pController.m_pGSAPI	=	self;
	pController.m_pSavedContext	=	pContext;
	pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
	UINavigationController *navigationController = [[UINavigationController alloc]
													initWithRootViewController:pController];
	navigationController.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
	[self.m_pMainViewController presentModalViewController:navigationController animated:YES];
	
	[pController release];	
	[navigationController release];
}

- (void) RemoveConnection:(GSDictionary *)pParams	context:(id)pContext
{
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:RemoveConnectionCompleted_Notification APIMethod:@"socialize.removeConnection" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:pContext];
		return;
	}
	
	
	if([pParams getString:GSAPI_PARAM_NAME_PROVIDER]	==	nil	|| [[[pParams getString:GSAPI_PARAM_NAME_PROVIDER] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] length] == 0)
	{
		[self SendNotification:RemoveConnectionCompleted_Notification APIMethod:@"socialize.removeConnection" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_MissingArgument] autorelease] context:pContext];
		return;
	}
	
	if([self GetAccessToken]	==	nil)
	{
		[self SendNotification:RemoveConnectionCompleted_Notification APIMethod:@"socialize.removeConnection" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession] autorelease] context:pContext];
		return;
	}
	self.m_pNotificationMessage	=	RemoveConnectionCompleted_Notification;
	self.m_bNoReEntrantCallPending	=	YES;
	
	[self SendRequest:@"socialize.removeConnection" Params:pParams UseHTTPS:NO context:pContext];
	
}

-	(void) ShowAddConnectionsUI:(GSDictionary *)pParams context:(id)pContext
{
	
	if(self.m_bNoReEntrantCallPending)
	{
		[self SendNotification:ShowAddConnectionsUICompleted_Notification APIMethod:@"connect" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_NonReEntrantCallPending] autorelease] context:pContext];
		return;
	}
	if([self GetAccessToken]	==	nil)
	{
		[self SendNotification:ShowAddConnectionsUICompleted_Notification APIMethod:@"connect" request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession] autorelease] context:pContext];
		return;
	}
	
	self.m_bNoReEntrantCallPending	=	YES;
	self.m_pNotificationMessage	=	ShowAddConnectionsUICompleted_Notification;
	
	GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
	pController.delegate = self;
	pController.m_pRequestParams	=	pParams;
	pController.m_EventType	=	GSEventType_CONNECT;
	pController.m_ActionType	=	GSWebAction_NavigateToProviderSelector;
	pController.m_pGSAPI	=	self;
	pController.m_pSavedContext	=	pContext;
	pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
	UINavigationController *navigationController = [[UINavigationController alloc]
													initWithRootViewController:pController];
	navigationController.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
	[self.m_pMainViewController presentModalViewController:navigationController animated:YES];
	
	[pController release];	
	[navigationController release];
	
}

-	(void) SendRequest:(NSString	*)pMethod Params:(GSDictionary		*)pParams	UseHTTPS:(BOOL)bUseHTTPS context:(id)pContext
{
	if(self.m_pNotificationMessage	==	nil)
		self.m_pNotificationMessage	=	SendRequestCompleted_Notification;
	
	if(pMethod	==	nil	||	[pMethod	length]	==	0)
	{
		[self SendNotification:pMethod request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_MissingArgument] autorelease] context:pContext];
		return;
	}
	if([self GetSecretKey]	==	nil)
	{
		[self SendNotification:pMethod request:pParams response:[[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession] autorelease]  context:pContext];
		return;
	}
	
	GSRequest *pRequest = [[GSRequest alloc] initWithSessionToken:[self GetAccessToken] SecretKey:[self GetSecretKey] APIMethod:pMethod SendParams:pParams UseHTTPS:bUseHTTPS NotificationMessage:self.m_pNotificationMessage];
	[pRequest SendRequest:pContext];
	[pRequest	release];
	self.m_pNotificationMessage	=	nil;
}


-	(void)	SendNotification:(NSString *)pMessage APIMethod:(NSString *)pMethod request:(GSDictionary		*)pRequestParams response:(GSResponse *)pResponse context:(id)pContext
{
	if(pMessage	!=	nil)
	{
		NSMutableDictionary	*pDict = [[[NSMutableDictionary alloc] init] autorelease];
		if(pRequestParams != nil)
			[pDict	setObject:pRequestParams forKey:GSAPI_PARAM_NAME_REQUEST_PARAMS_DICTIONARY];
		if(pResponse != nil)
			[pDict	setObject:pResponse forKey:GSAPI_PARAM_NAME_GSRESPONSE];
		if(pContext)
			[pDict	setObject:pContext forKey:GSAPI_PARAM_NAME_CONEXT];
		if(pMethod	!=	nil)
			[pDict	setObject:pMethod forKey:GSAPI_PARAM_NAME_SEND_REQUEST_METHOD];
		
		NSNotification *pNotification = [NSNotification notificationWithName:pMessage object:self userInfo:pDict];
		
		[[NSNotificationQueue defaultQueue] enqueueNotification:pNotification postingStyle:NSPostWhenIdle];
	}
}
-	(void)	SendNotification:(NSString *)pMethod request:(GSDictionary		*)pRequestParams response:(GSResponse *)pResponse context:(id)pContext
{
	[self SendNotification:self.m_pNotificationMessage APIMethod:pMethod request:pRequestParams response:pResponse context:pContext];
}




-(GSSession *) GetSession
{
	if(self.m_pSession	&&	[self.m_pSession	IsValid])
		return self.m_pSession;
	return nil;
	
}



@end
