//
//  GSDictionary.h
//  GigyaGSAPITester
//
//  Created by Moshe Shitrit on 7/22/10.
//  Copyright 2010 Mitug Distributed Systems Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface GSDictionary : NSObject {

	NSMutableDictionary *m_pDict;
	
}

@property (nonatomic, retain) NSMutableDictionary *m_pDict;

/* PUBLIC */
/* build GSDictionary from JSON string*/
+ (id)		dictionaryWithJSONString:(NSString *)pJSONString;

/* put a key,value pair in the dictionary. supported types: GSDictionary, NSArray of GSDictionary, NSSring, int, long and bool */
- (void)	putGSDictionaryValue:(GSDictionary	*)pValue	forKey:(NSString *)pKey ;
- (void)	putNSArrayValue:(NSArray	*)pValue	forKey:(NSString *)pKey; //array of GSDictionary
- (void)	putStringValue:(NSString	*)pValue	forKey:(NSString *)pKey;
- (void)	putIntValue:(int)Value	forKey:(NSString *)pKey;
- (void)	putLongValue:(long)Value	forKey:(NSString *)pKey;
- (void)	putBoolValue:(bool)Value	forKey:(NSString *)pKey;

/* get value by key*/
- (int)		getInt:(NSString *)key;
- (int)		getInt:(NSString *)key defaultValue:(int)value;

- (long)	getLong:(NSString *)key;
- (long)	getLong:(NSString *)key defaultValue:(long)value;

- (bool)	getBool:(NSString *)key;
- (bool)	getBool:(NSString *)key defaultValue:(bool)value;


- (NSString *)	getString:(NSString *)key;
- (NSString *)	getString:(NSString *)key defaultValue:(NSString *)value;

- (GSDictionary *)	getObject:(NSString *)key;
- (NSArray *)	getArray:(NSString *)key; //array of GSDictionary

- (void) remove:(NSString		*)key;
- (bool) contains:(NSString		*)key;
- (void) clear;
- (NSArray *)	getKeys;
- (NSString *)	stringValue; // returns json representation of the dictionary
- (int) count;

/* PRIVATE (USED INTERNALLY) */

/* build GSDictionary from url (containing a query string) */
+ (id)		dictionaryWithURL:(NSString *)pURL;
/* get dictionary values as query string */
- (NSString	*)toQueryString;
/* convert GSDictionary to NSDictionary*/
- (NSDictionary *) toNSDictionary;

@end

@interface NSString (NSString_GSDictionary)
-	(id) stringValue;
@end


