//
//  GSResponse.h
//  GigyaGSAPITester
//
//  Created by Moshe Shitrit on 7/19/10.
//  Copyright 2010 Mitug Distributed Systems Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "GSDictionary.h"

/* local error codes. other error codes are returned from the server */
typedef enum GSErrorCode
{
	GSErrorCode_MissingArgument = 400002,
	GSErrorCode_HTTPFailure = 500026,
	GSErrorCode_InvalidSession = 403000
	
} GSErrorCode;

@interface GSResponse : NSObject
{
	@private
	NSString		*errorMessage; // error message
	int				errorCode; // error code should be 0 on success
	NSString		*responseText; // raw response text	
	GSDictionary	*data; // response data
}

@property (nonatomic)			int				errorCode;
@property (nonatomic, retain) 	NSString		*errorMessage;
@property (nonatomic, retain) 	GSDictionary	*data;
@property (nonatomic, retain) 	NSString		*responseText;

@end

@interface GSResponse (Private_Internal)
- (id) initWithResponseData:(GSDictionary*)pResponseData;
- (id) initWithError:(int)Error;
- (id) initWithError:(int)Error ErrorMessage:(NSString *)pMsg ;
@end







