//
//  GSResponse.m
//  GigyaGSAPITester
//
//  Created by Moshe Shitrit on 7/19/10.
//  Copyright 2010 Mitug Distributed Systems Ltd. All rights reserved.
//

#import "GSResponse.h"


@implementation GSResponse

@synthesize	errorCode;
@synthesize	errorMessage;
@synthesize data;
@synthesize	responseText;


- (id) initWithResponseData:(GSDictionary	*)pData
{
	if ((self = [super init])) {
		self.errorCode	=	0;
		self.data	=	pData;
	}
	return self;
	
}

- (id) initWithError:(int)Error
{
	if ((self = [super init])) {
		self.errorCode	=	Error;
		
		switch (Error) {
			case	GSErrorCode_MissingArgument	:
				self.errorMessage	=	@"Required parameter is missing";
				break;
			case	GSErrorCode_HTTPFailure	:
				self.errorMessage	=	@"No Internet Connection";
				break;
			case	GSErrorCode_InvalidSession	:
				self.errorMessage	=	@"Invalid or missing session";
				break;
			default:
				self.errorMessage	=	@"Unspecified Error";
				break;
		}
		
		
	}
	return self;
	
}

- (id) initWithError:(int)Error ErrorMessage:(NSString *)pMsg 
{
	if ((self = [super init])) {
		self.errorCode	=	Error;
		self.errorMessage	=	pMsg;
		
	}
	return self;
	
}


- (void)dealloc {
	self.errorMessage	=	nil;
	self.data	=	nil;
	self.responseText	=	nil;
	[super dealloc];
}


@end
