//
//  ProviderSelectorViewController.m
//  GigyaGSAPITester
//
//  Created by Moshe Shitrit on 7/16/10.
//  Copyright 2010 Mitug Distributed Systems Ltd. All rights reserved.
//

#import "GSWebViewController.h"
#import	"GSRequest.h"

@implementation GSWebViewController
@synthesize	m_pWebView;
@synthesize	m_EventType;
@synthesize	m_pRequestParams;
@synthesize delegate;
@synthesize	m_pGSAPI;
@synthesize	m_ActionType;
@synthesize	m_pResponse;
@synthesize	m_pSavedContext;
@synthesize	m_pNotificationMessage;
@synthesize	m_bFirstAppearance;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];
	UIBarButtonItem *pCancelButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Cancel" style:UIBarButtonItemStyleBordered target:self action:@selector(OnCancel:)];
	self.navigationItem.rightBarButtonItem = pCancelButtonItem;
	[pCancelButtonItem release];
	
	UIBarButtonItem *pBackButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"Back" style:UIBarButtonItemStyleBordered target:self action:@selector(OnBack:)];
	self.navigationItem.backBarButtonItem = pBackButtonItem;
	[pBackButtonItem release];
	self.m_bFirstAppearance	=	YES;
}

-(IBAction)	OnBack:(id)Sender
{
	[self.navigationController popViewControllerAnimated:YES];
}



- (void) viewDidAppear:(BOOL)animated
{
	if(self.m_bFirstAppearance)
	{
	if(self.m_ActionType	==	GSWebAction_NavigateToLogin)
		[self NavigateToLogin];
	else if(self.m_ActionType	==	GSWebAction_NavigateToProviderSelector)
		[self NavigateToProviderSelector];
	else if(self.m_ActionType	==	GSWebAction_NavigateToConnect)
		[self NavigateToConnect];
	}
	self.m_bFirstAppearance	=	NO;
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	[super viewDidUnload];
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	self.m_pWebView	=	nil;
}


- (void)dealloc {
	NSNotification *pNotification;
	if(self.m_ActionType == GSWebAction_NavigateToProviderSelector)
	{
		NSMutableDictionary	*pDict = [[[NSMutableDictionary alloc] init] autorelease];
		[pDict	setObject:self.m_pSavedContext forKey:GSAPI_PARAM_NAME_CONEXT];

		if(self.m_EventType	==	GSEventType_CONNECT)
		{
			pNotification = [NSNotification notificationWithName:ShowAddConnectionsUIClosed_Notification object:nil userInfo:pDict];
		}	else {
			pNotification = [NSNotification notificationWithName:ShowLoginUIClosed_Notification object:nil userInfo:pDict];
		}
		[[NSNotificationQueue defaultQueue] enqueueNotification:pNotification postingStyle:NSPostWhenIdle];
	}
	
	
	
	self.m_pWebView	=	nil;
	self.m_pRequestParams	=	nil;
	self.m_pGSAPI	=	nil;
	self.m_pResponse	=	nil;
	self.m_pSavedContext	=	nil;
	self.m_pNotificationMessage	=	nil;
	[super dealloc];
}

-	(NSString	*)GetProvider
{
	if(self.m_pRequestParams	==	nil)
	{
		return nil;
	}
	return [self.m_pRequestParams	getString:GSAPI_PARAM_NAME_PROVIDER];
}
-	(NSString	*)GetProviderDisplayName
{
	if(self.m_pRequestParams	==	nil)
	{
		return nil;
	}
	NSString *pDisplayName	=	[self.m_pRequestParams	getString:GSAPI_PARAM_NAME_PROVIDER_DISPLAY_NAME];
	if(pDisplayName	!=	nil)
		return pDisplayName;
	return [self GetProvider];
}

-	(NSString	*)GetCID
{
	if(self.m_pRequestParams	==	nil)
	{
		return nil;
	}
	return [self.m_pRequestParams	getString:GSAPI_PARAM_NAME_CID];
}

-	(NSString	*)GetLang
{
	if(self.m_pRequestParams	==	nil)
	{
		return nil;
	}
	return [self.m_pRequestParams	getString:GSAPI_PARAM_NAME_LANG];
}

-	(NSString	*)GetExtraPermissions
{
	if(self.m_pRequestParams	==	nil)
		return nil;

	NSString* provider = [self GetProvider];
	
	if (provider==nil)
		return nil;
	NSString* xpermKey =  [provider stringByAppendingString:@"ExtraPermissions"];
	return [self.m_pRequestParams	getString:xpermKey];
}


-(void) NavigateToLogin
{
	if(self.m_ActionType != GSWebAction_NavigateToLogin)
	{
		GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
		pController.delegate = self.delegate;
		pController.m_pRequestParams	=	self.m_pRequestParams;
		pController.m_EventType	=	GSEventType_LOGIN;
		pController.m_ActionType	=	GSWebAction_NavigateToLogin;
		pController.m_pGSAPI	=	self.m_pGSAPI;
		pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
		pController.m_pSavedContext	=	self.m_pSavedContext;
		[self.navigationController pushViewController:pController animated:YES];
		[pController release];	
		return;
	}
	self.m_EventType	=	GSEventType_LOGIN;
	
	NSString	*pProvider = [self GetProvider];
	if(pProvider	==	nil)
	{
		self.m_pResponse	=	[[GSResponse	alloc] initWithError:GSErrorCode_MissingArgument];
		[self.delegate GSWebViewControllerDidFinish:self];
		return;
	}
	
	self.title	=	[self GetProviderDisplayName];
	
	GSDictionary *pServerParams= [[[GSDictionary alloc]init]autorelease];
	[pServerParams putStringValue:@"token" forKey:@"response_type"];
	[pServerParams putStringValue:self.m_pGSAPI.m_pAPIKey forKey:@"client_id"];
	[pServerParams putStringValue:GSAPI_RESULT_URL forKey:@"redirect_uri"];
	[pServerParams putStringValue:pProvider forKey:@"x_provider"];
	[pServerParams putStringValue:@"oauth1" forKey:@"x_secret_type"];
	if([self GetCID]	!=	nil)
		[pServerParams putStringValue:[self GetCID] forKey:@"x_cid"];
	if([self GetLang]	!=	nil)
		[pServerParams putStringValue:[self GetLang] forKey:@"x_lang"];
	if([self GetExtraPermissions]	!=	nil)
		[pServerParams putStringValue:[self GetExtraPermissions] forKey:@"x_extraPermissions"];
	
	
	NSURL *pURL = [NSURL URLWithString:[NSString stringWithFormat:@"%@?%@",GSAPI_LOGIN_URL,[pServerParams toQueryString]]];	
	[self.m_pWebView loadRequest:[NSURLRequest requestWithURL:pURL]];
}

-(void) NavigateToConnect
{
	if(self.m_ActionType != GSWebAction_NavigateToConnect)
	{
		
		GSWebViewController *pController = [[GSWebViewController alloc] initWithNibName:@"GSWebViewController" bundle:nil];
		pController.delegate = self.delegate;
		pController.m_pRequestParams	=	self.m_pRequestParams;
		pController.m_EventType	=	GSEventType_CONNECT;
		pController.m_ActionType	=	GSWebAction_NavigateToConnect;
		pController.m_pGSAPI	=	self.m_pGSAPI;
		pController.m_pNotificationMessage	=	self.m_pNotificationMessage;
		pController.m_pSavedContext	=	self.m_pSavedContext;
		[self.navigationController pushViewController:pController animated:YES];
		[pController release];	
		return;
	}
	
	self.m_EventType	=	GSEventType_CONNECT;
	
	NSString	*pProvider = [self GetProvider];
	if(pProvider	==	nil)
	{
		self.m_pResponse	=	[[GSResponse	alloc] initWithError:GSErrorCode_MissingArgument];
		[self.delegate GSWebViewControllerDidFinish:self];
		return;
	}
	
	NSString	*pAccessToken = [self.m_pGSAPI GetAccessToken];
	if(pAccessToken	==	nil)
	{
		self.m_pResponse	=	[[GSResponse	alloc] initWithError:GSErrorCode_InvalidSession];
		[self.delegate GSWebViewControllerDidFinish:self];
		return;
	}
	self.title	=	[self GetProviderDisplayName];
	
	GSDictionary *pServerParams= [[[GSDictionary alloc]init]autorelease];
	
	[pServerParams putStringValue:pAccessToken forKey:@"oauth_token"];
	[pServerParams putStringValue:@"token" forKey:@"response_type"];
	[pServerParams putStringValue:self.m_pGSAPI.m_pAPIKey forKey:@"client_id"];
	[pServerParams putStringValue:GSAPI_RESULT_URL forKey:@"redirect_uri"];
	[pServerParams putStringValue:pProvider forKey:@"x_provider"];
	[pServerParams putStringValue:@"oauth1" forKey:@"x_secret_type"];
	if([self GetCID]	!=	nil)
		[pServerParams putStringValue:[self GetCID] forKey:@"x_cid"];
	if([self GetLang]	!=	nil)
		[pServerParams putStringValue:[self GetLang] forKey:@"x_lang"];
	if([self GetExtraPermissions]	!=	nil)
		[pServerParams putStringValue:[self GetExtraPermissions] forKey:@"x_extraPermissions"];
	
	NSURL *pURL = [NSURL URLWithString:[NSString stringWithFormat:@"%@?%@",GSAPI_CONNECT_URL,[pServerParams toQueryString]]];	
	[self.m_pWebView loadRequest:[NSURLRequest requestWithURL:pURL]];
}


-(void) NavigateToProviderSelector
{
	if(self.m_pRequestParams	==	nil)
	{
		self.m_pRequestParams	=	[[GSDictionary alloc] init];
	}
	
	if(self.m_EventType	==	GSEventType_CONNECT)
	{
		NSString	*pAccessToken = [self.m_pGSAPI GetAccessToken];
		if(pAccessToken	==	nil)
		{
			self.m_pResponse	=	[[GSResponse alloc] initWithError:GSErrorCode_InvalidSession];
			[self.delegate GSWebViewControllerDidFinish:self];
			return;
		} else {
			[self.m_pRequestParams	putStringValue:pAccessToken forKey:@"oauth_token"];
		}
	}
	
	[self.m_pRequestParams	putStringValue:GSAPI_NET_SELECT_URL forKey:@"redirect_uri"];
	if([self.m_pGSAPI GetLastLoginProvider] != nil)
		[self.m_pRequestParams	putStringValue:[self.m_pGSAPI GetLastLoginProvider] forKey:@"lastLoginProvider"];
	
	NSURL *pURL = [NSURL URLWithString:[NSString stringWithFormat:@"%@?%@",GSAPI_UI_URL,[self.m_pRequestParams toQueryString]]];	
	[self.m_pWebView loadRequest:[NSURLRequest requestWithURL:pURL]];
	NSString	*pTitle = [self.m_pRequestParams getString:GSAPI_PARAM_NAME_CAPTION_TEXT];
	if(pTitle	==	nil)
	{
		if(self.m_EventType	==	GSEventType_CONNECT)
			self.title	=	@"Add a connection";
		else
			self.title	=	@"Login";
	}	else {
		self.title	=	pTitle;
	}
	
}




- (BOOL)webView:(UIWebView*)webView shouldStartLoadWithRequest:(NSURLRequest*)request navigationType:(UIWebViewNavigationType)navigationType 
{
#ifdef	_DEBUG
	NSLog(@"Should Start WebView Request URL = %@\nhost=%@\npath=%@",[[request URL] absoluteString],[[request URL] host],[[request URL] path]);
#endif
	
	NSString	*pURL = [[request	URL] absoluteString];
	
	
	if([pURL	rangeOfString:GSAPI_NET_SELECT_URL].location == 0)
	{
		GSDictionary	*pQSParams	=	[GSDictionary dictionaryWithURL:[[request URL]absoluteString] ];
		if([pQSParams getString:GSAPI_PARAM_NAME_PROVIDER] != nil)
		{
			[self.m_pRequestParams putStringValue:[pQSParams getString:GSAPI_PARAM_NAME_PROVIDER] forKey:GSAPI_PARAM_NAME_PROVIDER];
			if([pQSParams getString:GSAPI_PARAM_NAME_PROVIDER_DISPLAY_NAME] != nil)
			{
				[self.m_pRequestParams putStringValue:[pQSParams getString:GSAPI_PARAM_NAME_PROVIDER_DISPLAY_NAME] forKey:GSAPI_PARAM_NAME_PROVIDER_DISPLAY_NAME];
			}
			if(self.m_EventType	==	GSEventType_LOGIN)
			{
				[self NavigateToLogin];
			} else 	if(self.m_EventType	==	GSEventType_CONNECT)
			{
				[self NavigateToConnect];
			}
		}	else 
		{
			self.m_pResponse	=	[[GSResponse	alloc] initWithError:GSErrorCode_MissingArgument];
			[self.delegate GSWebViewControllerDidFinish:self];
		}
		return NO;
	} else if([pURL	rangeOfString:GSAPI_RESULT_URL].location == 0)
	{
		GSDictionary	*pQSParams	=	[GSDictionary dictionaryWithURL:[[request URL]absoluteString] ];
		[self OnResult:pQSParams];
		return NO;
	} else if([pURL	rangeOfString:GSAPI_TITLE_URL].location == 0)
	{
		GSDictionary	*pQSParams	=	[GSDictionary dictionaryWithURL:[[request URL]absoluteString] ];
		if([pQSParams getString:@"title"] != nil)
			self.title	=	[pQSParams getString:@"title"];
		return NO;
	}	
	return YES;
}


-(void) OnResult:(GSDictionary *)pResponse
{
#ifdef _DEBUG
	NSLog(@"On Result -> Response = %@\n",pResponse);
#endif
	
	if([pResponse getString:GSAPI_PARAM_NAME_ERROR_DESCRIPTION] !=nil)
	{
		NSArray	*pArray = [[pResponse getString:GSAPI_PARAM_NAME_ERROR_DESCRIPTION] componentsSeparatedByString:@"-"];
		self.m_pResponse = [[GSResponse	alloc] initWithError:[[[pArray objectAtIndex:0] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]] intValue] ErrorMessage:[[pArray objectAtIndex:1] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]]];
	}	else {
		self.m_pResponse = [[GSResponse	alloc] initWithResponseData:pResponse];
	}
	[self.delegate GSWebViewControllerDidFinish:self];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
#ifdef	_DEBUG
	NSLog(@"WebView Request Finished URL = %@\nhost=%@\npath=%@",[[webView.request URL] absoluteString],[[webView.request URL] host],[[webView.request URL] path]);
#endif
	
	NSString	*pURL = [[webView.request	URL] absoluteString];
	
	
	if([pURL	rangeOfString:GSAPI_UI_URL].location == 0)
	{
		NSMutableDictionary	*pDict = [[[NSMutableDictionary alloc] init] autorelease];
		[pDict	setObject:self.m_pSavedContext forKey:GSAPI_PARAM_NAME_CONEXT];

		NSNotification *pNotification;
		if(self.m_EventType	==	GSEventType_CONNECT)
		{
			pNotification = [NSNotification notificationWithName:ShowAddConnectionsUILoaded_Notification object:nil userInfo:pDict];
		}	else {
			pNotification = [NSNotification notificationWithName:ShowLoginUILoaded_Notification object:nil userInfo:pDict];
		}
		[[NSNotificationQueue defaultQueue] enqueueNotification:pNotification postingStyle:NSPostWhenIdle];
	}
	
}


- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
	
	#ifdef	_DEBUG
		NSLog(@"WebView failed loading. errorMessage=%@",[error localizedDescription]);
	#endif
	
	if([error code] == NSURLErrorCancelled)
		return;
	GSResponse	*pResponse	=	[[[GSResponse	alloc] initWithError:GSErrorCode_HTTPFailure] autorelease];
	pResponse.errorMessage	=	[error localizedDescription];
	
	
	NSMutableDictionary	*pDict = [[[NSMutableDictionary alloc] init] autorelease];
	[pDict	setObject:pResponse forKey:GSAPI_PARAM_NAME_GSRESPONSE];
	[pDict	setObject:self.m_pSavedContext forKey:GSAPI_PARAM_NAME_CONEXT];
	
	NSNotification *pNotification;
	if(self.m_EventType	==	GSEventType_CONNECT)
	{
		pNotification = [NSNotification notificationWithName:ShowAddConnectionsUIFailed_Notification object:nil userInfo:pDict];
	}	else {
		pNotification = [NSNotification notificationWithName:ShowLoginUIFailed_Notification object:nil userInfo:pDict];
	}
	
	[[NSNotificationQueue defaultQueue] enqueueNotification:pNotification postingStyle:NSPostWhenIdle];
	self.m_pResponse	=	nil;
	[self.delegate GSWebViewControllerDidFinish:self];
}

-(IBAction)	OnCancel:(id)Sender
{
	self.m_pResponse	=	[[GSResponse	alloc] initWithError:GSErrorCode_CancelledByUser];
	[self.delegate GSWebViewControllerDidFinish:self];
}


@end
